Index: branch/egtra-gdiplus/Classes/System/Drawing/Imaging/misc.ab
===================================================================
--- Include/Classes/System/Drawing/Imaging/misc.ab	(revision 212)
+++ branch/egtra-gdiplus/Classes/System/Drawing/Imaging/misc.ab	(revision 241)
@@ -1,3 +1,3 @@
-' Classes/System/Drawing/Imaging/misc.ab
+'Classes/System/Drawing/Imaging/misc.ab
 
 #ifndef __SYSTEM_DRAWING_IMAGING_MISC_AB__
@@ -6,6 +6,7 @@
 #include <Classes/System/Drawing/Color.ab>
 
-TypeDef ARGB = DWord
-TypeDef ARGB64 = QWord
+Namespace System
+Namespace Drawing
+Namespace Imaging
 
 Enum ColorMode
@@ -13,10 +14,4 @@
 	ARGB64 = 1
 End Enum
-
-Const ALPHA_SHIFT = 24 As DWord
-Const RED_SHIFT   = 16 As DWord
-Const GREEN_SHIFT = 8 As DWord
-Const BLUE_SHIFT  = 0 As DWord
-Const ALPHA_MASK  = ((&hff As ARGB) << ALPHA_SHIFT)
 
 ' In-memory pixel data formats:
@@ -54,14 +49,4 @@
 End Enum
 
-Const GetPixelFormatSize(pixfmt) = ((((pixfmt As PixelFormat) >> 8) And &hff) As DWord)
-
-Const IsIndexedPixelFormat(pixfmt) = ((((pixfmt As PixelFormat) And PixelFormat.Indexed) <> 0) As BOOL)
-
-Const IsAlphaPixelFormat(pixfmt) = ((((pixfmt As PixelFormat) And PixelFormat.Alpha) <> 0) As BOOL)
-
-Const IsExtendedPixelFormat(pixfmt) = ((((pixfmt As PixelFormat) And PixelFormat.Extended) <> 0) As BOOL)
-
-Const IsCanonicalPixelFormat(pixfmt) = ((((pixfmt As PixelFormat) And PixelFormat.Canonical) <> 0) As BOOL)
-
 Enum PaletteFlags
 	PaletteFlagsHasAlpha    = &h0001
@@ -69,10 +54,4 @@
 	PaletteFlagsHalftone    = &h0004
 End Enum
-
-Type Align(8) ColorPalette
-	Flags As DWord
-	Count As DWord
-	Entries[1] As ARGB
-End Type
 
 Enum ColorAdjustType
@@ -86,8 +65,4 @@
 End Enum
 
-Type ColorMatrix
-	m[5][5] As Single
-End Type
-
 Type ColorMap
 	OldColor As Color
@@ -129,16 +104,4 @@
 End Type
 
-Type Align(8) EncoderParameter
-	Guid As GUID
-	NumberOfValues As DWord
-	EncoderType As DWord '元はTypeという名前
-	Value As VoidPtr
-End Type
-
-Type Align(8) EncoderParameters
-	Count As DWord
-	Parameter[1] As EncoderParameter
-End Type
-
 Type Align(8) PropertyItem
 	id As PROPID
@@ -148,285 +111,4 @@
 End Type
 
-Const PropertyTagTypeByte        = 1
-Const PropertyTagTypeASCII       = 2
-Const PropertyTagTypeShort       = 3
-Const PropertyTagTypeLong        = 4
-Const PropertyTagTypeRational    = 5
-Const PropertyTagTypeUndefined   = 7
-Const PropertyTagTypeSLONG       = 9
-Const PropertyTagTypeSRational  = 10
-
-Const PropertyTagExifIFD             = &h8769
-Const PropertyTagGpsIFD              = &h8825
-
-Const PropertyTagNewSubfileType      = &h00FE
-Const PropertyTagSubfileType         = &h00FF
-Const PropertyTagImageWidth          = &h0100
-Const PropertyTagImageHeight         = &h0101
-Const PropertyTagBitsPerSample       = &h0102
-Const PropertyTagCompression         = &h0103
-Const PropertyTagPhotometricInterp   = &h0106
-Const PropertyTagThreshHolding       = &h0107
-Const PropertyTagCellWidth           = &h0108
-Const PropertyTagCellHeight          = &h0109
-Const PropertyTagFillOrder           = &h010A
-Const PropertyTagDocumentName        = &h010D
-Const PropertyTagImageDescription    = &h010E
-Const PropertyTagEquipMake           = &h010F
-Const PropertyTagEquipModel          = &h0110
-Const PropertyTagStripOffsets        = &h0111
-Const PropertyTagOrientation         = &h0112
-Const PropertyTagSamplesPerPixel     = &h0115
-Const PropertyTagRowsPerStrip        = &h0116
-Const PropertyTagStripBytesCount     = &h0117
-Const PropertyTagMinSampleValue      = &h0118
-Const PropertyTagMaxSampleValue      = &h0119
-Const PropertyTagXResolution         = &h011A   ' Image resolution in width direction
-Const PropertyTagYResolution         = &h011B   ' Image resolution in height direction
-Const PropertyTagPlanarConfig        = &h011C   ' Image data arrangement
-Const PropertyTagPageName            = &h011D
-Const PropertyTagXPosition           = &h011E
-Const PropertyTagYPosition           = &h011F
-Const PropertyTagFreeOffset          = &h0120
-Const PropertyTagFreeByteCounts      = &h0121
-Const PropertyTagGrayResponseUnit    = &h0122
-Const PropertyTagGrayResponseCurve   = &h0123
-Const PropertyTagT4Option            = &h0124
-Const PropertyTagT6Option            = &h0125
-Const PropertyTagResolutionUnit      = &h0128   ' Unit of X and Y resolution
-Const PropertyTagPageNumber          = &h0129
-Const PropertyTagTransferFuncition   = &h012D
-Const PropertyTagSoftwareUsed        = &h0131
-Const PropertyTagDateTime            = &h0132
-Const PropertyTagArtist              = &h013B
-Const PropertyTagHostComputer        = &h013C
-Const PropertyTagPredictor           = &h013D
-Const PropertyTagWhitePoint          = &h013E
-Const PropertyTagPrimaryChromaticities = &h013F
-Const PropertyTagColorMap            = &h0140
-Const PropertyTagHalftoneHints       = &h0141
-Const PropertyTagTileWidth           = &h0142
-Const PropertyTagTileLength          = &h0143
-Const PropertyTagTileOffset          = &h0144
-Const PropertyTagTileByteCounts      = &h0145
-Const PropertyTagInkSet              = &h014C
-Const PropertyTagInkNames            = &h014D
-Const PropertyTagNumberOfInks        = &h014E
-Const PropertyTagDotRange            = &h0150
-Const PropertyTagTargetPrinter       = &h0151
-Const PropertyTagExtraSamples        = &h0152
-Const PropertyTagSampleFormat        = &h0153
-Const PropertyTagSMinSampleValue     = &h0154
-Const PropertyTagSMaxSampleValue     = &h0155
-Const PropertyTagTransferRange       = &h0156
-
-Const PropertyTagJPEGProc            = &h0200
-Const PropertyTagJPEGInterFormat     = &h0201
-Const PropertyTagJPEGInterLength     = &h0202
-Const PropertyTagJPEGRestartInterval = &h0203
-Const PropertyTagJPEGLosslessPredictors  = &h0205
-Const PropertyTagJPEGPointTransforms     = &h0206
-Const PropertyTagJPEGQTables         = &h0207
-Const PropertyTagJPEGDCTables        = &h0208
-Const PropertyTagJPEGACTables        = &h0209
-
-Const PropertyTagYCbCrCoefficients   = &h0211
-Const PropertyTagYCbCrSubsampling    = &h0212
-Const PropertyTagYCbCrPositioning    = &h0213
-Const PropertyTagREFBlackWhite       = &h0214
-
-Const PropertyTagICCProfile          = &h8773   ' This TAG is defined by ICC
-                                                ' for embedded ICC in TIFF
-Const PropertyTagGamma               = &h0301
-Const PropertyTagICCProfileDescriptor = &h0302
-Const PropertyTagSRGBRenderingIntent = &h0303
-
-Const PropertyTagImageTitle          = &h0320
-Const PropertyTagCopyright           = &h8298
-
-' Extra TAGs (Like Adobe Image Information tags etc.)
-
-Const PropertyTagResolutionXUnit           = &h5001
-Const PropertyTagResolutionYUnit           = &h5002
-Const PropertyTagResolutionXLengthUnit     = &h5003
-Const PropertyTagResolutionYLengthUnit     = &h5004
-Const PropertyTagPrintFlags                = &h5005
-Const PropertyTagPrintFlagsVersion         = &h5006
-Const PropertyTagPrintFlagsCrop            = &h5007
-Const PropertyTagPrintFlagsBleedWidth      = &h5008
-Const PropertyTagPrintFlagsBleedWidthScale = &h5009
-Const PropertyTagHalftoneLPI               = &h500A
-Const PropertyTagHalftoneLPIUnit           = &h500B
-Const PropertyTagHalftoneDegree            = &h500C
-Const PropertyTagHalftoneShape             = &h500D
-Const PropertyTagHalftoneMisc              = &h500E
-Const PropertyTagHalftoneScreen            = &h500F
-Const PropertyTagJPEGQuality               = &h5010
-Const PropertyTagGridSize                  = &h5011
-Const PropertyTagThumbnailFormat           = &h5012  ' 1 = JPEG, 0 = RAW RGB
-Const PropertyTagThumbnailWidth            = &h5013
-Const PropertyTagThumbnailHeight           = &h5014
-Const PropertyTagThumbnailColorDepth       = &h5015
-Const PropertyTagThumbnailPlanes           = &h5016
-Const PropertyTagThumbnailRawBytes         = &h5017
-Const PropertyTagThumbnailSize             = &h5018
-Const PropertyTagThumbnailCompressedSize   = &h5019
-Const PropertyTagColorTransferFunction     = &h501A
-Const PropertyTagThumbnailData             = &h501B' RAW thumbnail bits in
-                                                   ' JPEG format or RGB format
-                                                   ' depends on
-                                                   ' PropertyTagThumbnailFormat
-
-' Thumbnail related TAGs
-
-Const PropertyTagThumbnailImageWidth       = &h5020  ' Thumbnail width
-Const PropertyTagThumbnailImageHeight      = &h5021  ' Thumbnail height
-Const PropertyTagThumbnailBitsPerSample    = &h5022  ' Number of bits per
-                                                     ' component
-Const PropertyTagThumbnailCompression      = &h5023  ' Compression Scheme
-Const PropertyTagThumbnailPhotometricInterp = &h5024 ' Pixel composition
-Const PropertyTagThumbnailImageDescription = &h5025  ' Image Tile
-Const PropertyTagThumbnailEquipMake        = &h5026  ' Manufacturer of Image
-                                                     ' Input equipment
-Const PropertyTagThumbnailEquipModel       = &h5027  ' Model of Image input
-                                                     ' equipment
-Const PropertyTagThumbnailStripOffsets     = &h5028  ' Image data location
-Const PropertyTagThumbnailOrientation      = &h5029  ' Orientation of image
-Const PropertyTagThumbnailSamplesPerPixel  = &h502A  ' Number of components
-Const PropertyTagThumbnailRowsPerStrip     = &h502B  ' Number of rows per strip
-Const PropertyTagThumbnailStripBytesCount  = &h502C  ' Bytes per compressed
-                                                     ' strip
-Const PropertyTagThumbnailResolutionX      = &h502D  ' Resolution in width
-                                                     ' direction
-Const PropertyTagThumbnailResolutionY      = &h502E  ' Resolution in height
-                                                     ' direction
-Const PropertyTagThumbnailPlanarConfig     = &h502F  ' Image data arrangement
-Const PropertyTagThumbnailResolutionUnit   = &h5030  ' Unit of X and Y
-                                                     ' Resolution
-Const PropertyTagThumbnailTransferFunction = &h5031  ' Transfer function
-Const PropertyTagThumbnailSoftwareUsed     = &h5032  ' Software used
-Const PropertyTagThumbnailDateTime         = &h5033  ' File change date and
-                                                     ' time
-Const PropertyTagThumbnailArtist           = &h5034  ' Person who created the
-                                                     ' image
-Const PropertyTagThumbnailWhitePoint       = &h5035  ' White point chromaticity
-Const PropertyTagThumbnailPrimaryChromaticities = &h5036
-                                                     ' Chromaticities of
-                                                     ' primaries
-Const PropertyTagThumbnailYCbCrCoefficients = &h5037 ' Color space transforma-
-                                                     ' tion coefficients
-Const PropertyTagThumbnailYCbCrSubsampling = &h5038  ' Subsampling ratio of Y
-                                                     ' to C
-Const PropertyTagThumbnailYCbCrPositioning = &h5039  ' Y and C position
-Const PropertyTagThumbnailRefBlackWhite    = &h503A  ' Pair of black and white
-                                                     ' reference values
-Const PropertyTagThumbnailCopyRight        = &h503B  ' CopyRight holder
-
-Const PropertyTagLuminanceTable            = &h5090
-Const PropertyTagChrominanceTable          = &h5091
-
-Const PropertyTagFrameDelay                = &h5100
-Const PropertyTagLoopCount                 = &h5101
-
-Const PropertyTagPixelUnit         = &h5110  ' Unit specifier for pixel/unit
-Const PropertyTagPixelPerUnitX     = &h5111  ' Pixels per unit in X
-Const PropertyTagPixelPerUnitY     = &h5112  ' Pixels per unit in Y
-Const PropertyTagPaletteHistogram  = &h5113  ' Palette histogram
-
-' EXIF specific tag
-
-Const PropertyTagExifExposureTime  = &h829A
-Const PropertyTagExifFNumber       = &h829D
-
-Const PropertyTagExifExposureProg  = &h8822
-Const PropertyTagExifSpectralSense = &h8824
-Const PropertyTagExifISOSpeed      = &h8827
-Const PropertyTagExifOECF          = &h8828
-
-Const PropertyTagExifVer            = &h9000
-Const PropertyTagExifDTOrig         = &h9003 ' Date & time of original
-Const PropertyTagExifDTDigitized    = &h9004 ' Date & time of digital data generation
-
-Const PropertyTagExifCompConfig     = &h9101
-Const PropertyTagExifCompBPP        = &h9102
-
-Const PropertyTagExifShutterSpeed   = &h9201
-Const PropertyTagExifAperture       = &h9202
-Const PropertyTagExifBrightness     = &h9203
-Const PropertyTagExifExposureBias   = &h9204
-Const PropertyTagExifMaxAperture    = &h9205
-Const PropertyTagExifSubjectDist    = &h9206
-Const PropertyTagExifMeteringMode   = &h9207
-Const PropertyTagExifLightSource    = &h9208
-Const PropertyTagExifFlash          = &h9209
-Const PropertyTagExifFocalLength    = &h920A
-Const PropertyTagExifMakerNote      = &h927C
-Const PropertyTagExifUserComment    = &h9286
-Const PropertyTagExifDTSubsec       = &h9290  ' Date & Time subseconds
-Const PropertyTagExifDTOrigSS       = &h9291  ' Date & Time original subseconds
-Const PropertyTagExifDTDigSS        = &h9292  ' Date & TIme digitized subseconds
-
-Const PropertyTagExifFPXVer         = &hA000
-Const PropertyTagExifColorSpace     = &hA001
-Const PropertyTagExifPixXDim        = &hA002
-Const PropertyTagExifPixYDim        = &hA003
-Const PropertyTagExifRelatedWav     = &hA004  ' related sound file
-Const PropertyTagExifInterop        = &hA005
-Const PropertyTagExifFlashEnergy    = &hA20B
-Const PropertyTagExifSpatialFR      = &hA20C  ' Spatial Frequency Response
-Const PropertyTagExifFocalXRes      = &hA20E  ' Focal Plane X Resolution
-Const PropertyTagExifFocalYRes      = &hA20F  ' Focal Plane Y Resolution
-Const PropertyTagExifFocalResUnit   = &hA210  ' Focal Plane Resolution Unit
-Const PropertyTagExifSubjectLoc     = &hA214
-Const PropertyTagExifExposureIndex  = &hA215
-Const PropertyTagExifSensingMethod  = &hA217
-Const PropertyTagExifFileSource     = &hA300
-Const PropertyTagExifSceneType      = &hA301
-Const PropertyTagExifCfaPattern     = &hA302
-
-Const PropertyTagGpsVer             = &h0000
-Const PropertyTagGpsLatitudeRef     = &h0001
-Const PropertyTagGpsLatitude        = &h0002
-Const PropertyTagGpsLongitudeRef    = &h0003
-Const PropertyTagGpsLongitude       = &h0004
-Const PropertyTagGpsAltitudeRef     = &h0005
-Const PropertyTagGpsAltitude        = &h0006
-Const PropertyTagGpsGpsTime         = &h0007
-Const PropertyTagGpsGpsSatellites   = &h0008
-Const PropertyTagGpsGpsStatus       = &h0009
-Const PropertyTagGpsGpsMeasureMode  = &h00A
-Const PropertyTagGpsGpsDop          = &h000B  ' Measurement precision
-Const PropertyTagGpsSpeedRef        = &h000C
-Const PropertyTagGpsSpeed           = &h000D
-Const PropertyTagGpsTrackRef        = &h000E
-Const PropertyTagGpsTrack           = &h000F
-Const PropertyTagGpsImgDirRef       = &h0010
-Const PropertyTagGpsImgDir          = &h0011
-Const PropertyTagGpsMapDatum        = &h0012
-Const PropertyTagGpsDestLatRef      = &h0013
-Const PropertyTagGpsDestLat         = &h0014
-Const PropertyTagGpsDestLongRef     = &h0015
-Const PropertyTagGpsDestLong        = &h0016
-Const PropertyTagGpsDestBearRef     = &h0017
-Const PropertyTagGpsDestBear        = &h0018
-Const PropertyTagGpsDestDistRef     = &h0019
-Const PropertyTagGpsDestDist        = &h001A
-
-Type ImageCodecInfo
-	Clsid As CLSID
-	FormatID As GUID
-	CodecName As PCWSTR
-	DllName As PCWSTR
-	FormatDescription As PCWSTR
-	FilenameExtension As PCWSTR
-	MimeType As PCWSTR
-	Flags As DWord
-	Version As DWord
-	SigCount As DWord
-	SigSize As DWord
-	SigPattern As *Byte
-	SigMask As DWord
-End Type
-
 Enum ColorChannelFlag
 	ColorChannelC = 0
@@ -437,3 +119,297 @@
 End Enum
 
+Const GDIP_EMFPLUS_RECORD_BASE        = &h00004000
+Const GDIP_WMF_RECORD_BASE            = &h00010000
+Const GDIP_WMF_RECORD_TO_EMFPLUS(n)   = ((n) Or GDIP_WMF_RECORD_BASE) ' As EmfPlusRecordType
+Const GDIP_EMFPLUS_RECORD_TO_WMF(n)   = ((n) And (Not GDIP_WMF_RECORD_BASE))
+'Const GDIP_IS_WMF_RECORDTYPE(n)       (((n) And GDIP_WMF_RECORD_BASE) <> 0)
+Function GDIP_IS_WMF_RECORDTYPE(n As DWord) As BOOL
+	If (n And GDIP_WMF_RECORD_BASE) <> 0 Then
+		GDIP_IS_WMF_RECORDTYPE = TRUE
+	Else
+		GDIP_IS_WMF_RECORDTYPE = FALSE
+	End If
+End Function
+
+Enum EmfPlusRecordType
+/*
+	WmfRecordTypeSetBkColor              = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETBKCOLOR)
+	WmfRecordTypeSetBkMode               = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETBKMODE)
+	WmfRecordTypeSetMapMode              = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETMAPMODE)
+	WmfRecordTypeSetROP2                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETROP2)
+	WmfRecordTypeSetRelAbs               = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETRELABS)
+	WmfRecordTypeSetPolyFillMode         = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPOLYFILLMODE)
+	WmfRecordTypeSetStretchBltMode       = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETSTRETCHBLTMODE)
+	WmfRecordTypeSetTextCharExtra        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTCHAREXTRA)
+	WmfRecordTypeSetTextColor            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTCOLOR)
+	WmfRecordTypeSetTextJustification    = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTJUSTIFICATION)
+	WmfRecordTypeSetWindowOrg            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETWINDOWORG)
+	WmfRecordTypeSetWindowExt            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETWINDOWEXT)
+	WmfRecordTypeSetViewportOrg          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETVIEWPORTORG)
+	WmfRecordTypeSetViewportExt          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETVIEWPORTEXT)
+	WmfRecordTypeOffsetWindowOrg         = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETWINDOWORG)
+	WmfRecordTypeScaleWindowExt          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SCALEWINDOWEXT)
+	WmfRecordTypeOffsetViewportOrg       = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETVIEWPORTORG)
+	WmfRecordTypeScaleViewportExt        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SCALEVIEWPORTEXT)
+	WmfRecordTypeLineTo                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_LINETO)
+	WmfRecordTypeMoveTo                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_MOVETO)
+	WmfRecordTypeExcludeClipRect         = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXCLUDECLIPRECT)
+	WmfRecordTypeIntersectClipRect       = GDIP_WMF_RECORD_TO_EMFPLUS(META_INTERSECTCLIPRECT)
+	WmfRecordTypeArc                     = GDIP_WMF_RECORD_TO_EMFPLUS(META_ARC)
+	WmfRecordTypeEllipse                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_ELLIPSE)
+	WmfRecordTypeFloodFill               = GDIP_WMF_RECORD_TO_EMFPLUS(META_FLOODFILL)
+	WmfRecordTypePie                     = GDIP_WMF_RECORD_TO_EMFPLUS(META_PIE)
+	WmfRecordTypeRectangle               = GDIP_WMF_RECORD_TO_EMFPLUS(META_RECTANGLE)
+	WmfRecordTypeRoundRect               = GDIP_WMF_RECORD_TO_EMFPLUS(META_ROUNDRECT)
+	WmfRecordTypePatBlt                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_PATBLT)
+	WmfRecordTypeSaveDC                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_SAVEDC)
+	WmfRecordTypeSetPixel                = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPIXEL)
+	WmfRecordTypeOffsetClipRgn           = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETCLIPRGN)
+	WmfRecordTypeTextOut                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_TEXTOUT)
+	WmfRecordTypeBitBlt                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_BITBLT)
+	WmfRecordTypeStretchBlt              = GDIP_WMF_RECORD_TO_EMFPLUS(META_STRETCHBLT)
+	WmfRecordTypePolygon                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYGON)
+	WmfRecordTypePolyline                = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYLINE)
+	WmfRecordTypeEscape                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_ESCAPE)
+	WmfRecordTypeRestoreDC               = GDIP_WMF_RECORD_TO_EMFPLUS(META_RESTOREDC)
+	WmfRecordTypeFillRegion              = GDIP_WMF_RECORD_TO_EMFPLUS(META_FILLREGION)
+	WmfRecordTypeFrameRegion             = GDIP_WMF_RECORD_TO_EMFPLUS(META_FRAMEREGION)
+	WmfRecordTypeInvertRegion            = GDIP_WMF_RECORD_TO_EMFPLUS(META_INVERTREGION)
+	WmfRecordTypePaintRegion             = GDIP_WMF_RECORD_TO_EMFPLUS(META_PAINTREGION)
+	WmfRecordTypeSelectClipRegion        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTCLIPREGION)
+	WmfRecordTypeSelectObject            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTOBJECT)
+	WmfRecordTypeSetTextAlign            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTALIGN)
+	WmfRecordTypeDrawText                = GDIP_WMF_RECORD_TO_EMFPLUS(&h062F)   ' META_DRAWTEXT
+	WmfRecordTypeChord                   = GDIP_WMF_RECORD_TO_EMFPLUS(META_CHORD)
+	WmfRecordTypeSetMapperFlags          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETMAPPERFLAGS)
+	WmfRecordTypeExtTextOut              = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXTTEXTOUT)
+	WmfRecordTypeSetDIBToDev             = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETDIBTODEV)
+	WmfRecordTypeSelectPalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTPALETTE)
+	WmfRecordTypeRealizePalette          = GDIP_WMF_RECORD_TO_EMFPLUS(META_REALIZEPALETTE)
+	WmfRecordTypeAnimatePalette          = GDIP_WMF_RECORD_TO_EMFPLUS(META_ANIMATEPALETTE)
+	WmfRecordTypeSetPalEntries           = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPALENTRIES)
+	WmfRecordTypePolyPolygon             = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYPOLYGON)
+	WmfRecordTypeResizePalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_RESIZEPALETTE)
+	WmfRecordTypeDIBBitBlt               = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBBITBLT)
+	WmfRecordTypeDIBStretchBlt           = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBSTRETCHBLT)
+	WmfRecordTypeDIBCreatePatternBrush   = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBCREATEPATTERNBRUSH)
+	WmfRecordTypeStretchDIB              = GDIP_WMF_RECORD_TO_EMFPLUS(META_STRETCHDIB)
+	WmfRecordTypeExtFloodFill            = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXTFLOODFILL)
+	WmfRecordTypeSetLayout               = GDIP_WMF_RECORD_TO_EMFPLUS(&h0149)   ' META_SETLAYOUT
+	WmfRecordTypeResetDC                 = GDIP_WMF_RECORD_TO_EMFPLUS(&h014C)   ' META_RESETDC
+	WmfRecordTypeStartDoc                = GDIP_WMF_RECORD_TO_EMFPLUS(&h014D)   ' META_STARTDOC
+	WmfRecordTypeStartPage               = GDIP_WMF_RECORD_TO_EMFPLUS(&h004F)   ' META_STARTPAGE
+	WmfRecordTypeEndPage                 = GDIP_WMF_RECORD_TO_EMFPLUS(&h0050)   ' META_ENDPAGE
+	WmfRecordTypeAbortDoc                = GDIP_WMF_RECORD_TO_EMFPLUS(&h0052)   ' META_ABORTDOC
+	WmfRecordTypeEndDoc                  = GDIP_WMF_RECORD_TO_EMFPLUS(&h005E)   ' META_ENDDOC
+	WmfRecordTypeDeleteObject            = GDIP_WMF_RECORD_TO_EMFPLUS(META_DELETEOBJECT)
+	WmfRecordTypeCreatePalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPALETTE)
+	WmfRecordTypeCreateBrush             = GDIP_WMF_RECORD_TO_EMFPLUS(&h00F8)   ' META_CREATEBRUSH
+	WmfRecordTypeCreatePatternBrush      = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPATTERNBRUSH)
+	WmfRecordTypeCreatePenIndirect       = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPENINDIRECT)
+	WmfRecordTypeCreateFontIndirect      = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEFONTINDIRECT)
+	WmfRecordTypeCreateBrushIndirect     = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEBRUSHINDIRECT)
+	WmfRecordTypeCreateBitmapIndirect    = GDIP_WMF_RECORD_TO_EMFPLUS(&h02FD)   ' META_CREATEBITMAPINDIRECT
+	WmfRecordTypeCreateBitmap            = GDIP_WMF_RECORD_TO_EMFPLUS(&h06FE)   ' META_CREATEBITMAP
+	WmfRecordTypeCreateRegion            = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEREGION)
+
+	EmfRecordTypeHeader                  = EMR_HEADER
+	EmfRecordTypePolyBezier              = EMR_POLYBEZIER
+	EmfRecordTypePolygon                 = EMR_POLYGON
+	EmfRecordTypePolyline                = EMR_POLYLINE
+	EmfRecordTypePolyBezierTo            = EMR_POLYBEZIERTO
+	EmfRecordTypePolyLineTo              = EMR_POLYLINETO
+	EmfRecordTypePolyPolyline            = EMR_POLYPOLYLINE
+	EmfRecordTypePolyPolygon             = EMR_POLYPOLYGON
+	EmfRecordTypeSetWindowExtEx          = EMR_SETWINDOWEXTEX
+	EmfRecordTypeSetWindowOrgEx          = EMR_SETWINDOWORGEX
+	EmfRecordTypeSetViewportExtEx        = EMR_SETVIEWPORTEXTEX
+	EmfRecordTypeSetViewportOrgEx        = EMR_SETVIEWPORTORGEX
+	EmfRecordTypeSetBrushOrgEx           = EMR_SETBRUSHORGEX
+	EmfRecordTypeEOF                     = EMR_EOF
+	EmfRecordTypeSetPixelV               = EMR_SETPIXELV
+	EmfRecordTypeSetMapperFlags          = EMR_SETMAPPERFLAGS
+	EmfRecordTypeSetMapMode              = EMR_SETMAPMODE
+	EmfRecordTypeSetBkMode               = EMR_SETBKMODE
+	EmfRecordTypeSetPolyFillMode         = EMR_SETPOLYFILLMODE
+	EmfRecordTypeSetROP2                 = EMR_SETROP2
+	EmfRecordTypeSetStretchBltMode       = EMR_SETSTRETCHBLTMODE
+	EmfRecordTypeSetTextAlign            = EMR_SETTEXTALIGN
+	EmfRecordTypeSetColorAdjustment      = EMR_SETCOLORADJUSTMENT
+	EmfRecordTypeSetTextColor            = EMR_SETTEXTCOLOR
+	EmfRecordTypeSetBkColor              = EMR_SETBKCOLOR
+	EmfRecordTypeOffsetClipRgn           = EMR_OFFSETCLIPRGN
+	EmfRecordTypeMoveToEx                = EMR_MOVETOEX
+	EmfRecordTypeSetMetaRgn              = EMR_SETMETARGN
+	EmfRecordTypeExcludeClipRect         = EMR_EXCLUDECLIPRECT
+	EmfRecordTypeIntersectClipRect       = EMR_INTERSECTCLIPRECT
+	EmfRecordTypeScaleViewportExtEx      = EMR_SCALEVIEWPORTEXTEX
+	EmfRecordTypeScaleWindowExtEx        = EMR_SCALEWINDOWEXTEX
+	EmfRecordTypeSaveDC                  = EMR_SAVEDC
+	EmfRecordTypeRestoreDC               = EMR_RESTOREDC
+	EmfRecordTypeSetWorldTransform       = EMR_SETWORLDTRANSFORM
+	EmfRecordTypeModifyWorldTransform    = EMR_MODIFYWORLDTRANSFORM
+	EmfRecordTypeSelectObject            = EMR_SELECTOBJECT
+	EmfRecordTypeCreatePen               = EMR_CREATEPEN
+	EmfRecordTypeCreateBrushIndirect     = EMR_CREATEBRUSHINDIRECT
+	EmfRecordTypeDeleteObject            = EMR_DELETEOBJECT
+	EmfRecordTypeAngleArc                = EMR_ANGLEARC
+	EmfRecordTypeEllipse                 = EMR_ELLIPSE
+	EmfRecordTypeRectangle               = EMR_RECTANGLE
+	EmfRecordTypeRoundRect               = EMR_ROUNDRECT
+	EmfRecordTypeArc                     = EMR_ARC
+	EmfRecordTypeChord                   = EMR_CHORD
+	EmfRecordTypePie                     = EMR_PIE
+	EmfRecordTypeSelectPalette           = EMR_SELECTPALETTE
+	EmfRecordTypeCreatePalette           = EMR_CREATEPALETTE
+	EmfRecordTypeSetPaletteEntries       = EMR_SETPALETTEENTRIES
+	EmfRecordTypeResizePalette           = EMR_RESIZEPALETTE
+	EmfRecordTypeRealizePalette          = EMR_REALIZEPALETTE
+	EmfRecordTypeExtFloodFill            = EMR_EXTFLOODFILL
+	EmfRecordTypeLineTo                  = EMR_LINETO
+	EmfRecordTypeArcTo                   = EMR_ARCTO
+	EmfRecordTypePolyDraw                = EMR_POLYDRAW
+	EmfRecordTypeSetArcDirection         = EMR_SETARCDIRECTION
+	EmfRecordTypeSetMiterLimit           = EMR_SETMITERLIMIT
+	EmfRecordTypeBeginPath               = EMR_BEGINPATH
+	EmfRecordTypeEndPath                 = EMR_ENDPATH
+	EmfRecordTypeCloseFigure             = EMR_CLOSEFIGURE
+	EmfRecordTypeFillPath                = EMR_FILLPATH
+	EmfRecordTypeStrokeAndFillPath       = EMR_STROKEANDFILLPATH
+	EmfRecordTypeStrokePath              = EMR_STROKEPATH
+	EmfRecordTypeFlattenPath             = EMR_FLATTENPATH
+	EmfRecordTypeWidenPath               = EMR_WIDENPATH
+	EmfRecordTypeSelectClipPath          = EMR_SELECTCLIPPATH
+	EmfRecordTypeAbortPath               = EMR_ABORTPATH
+	EmfRecordTypeReserved_069            = 69   ' Not Used
+	EmfRecordTypeGdiComment              = EMR_GDICOMMENT
+	EmfRecordTypeFillRgn                 = EMR_FILLRGN
+	EmfRecordTypeFrameRgn                = EMR_FRAMERGN
+	EmfRecordTypeInvertRgn               = EMR_INVERTRGN
+	EmfRecordTypePaintRgn                = EMR_PAINTRGN
+	EmfRecordTypeExtSelectClipRgn        = EMR_EXTSELECTCLIPRGN
+	EmfRecordTypeBitBlt                  = EMR_BITBLT
+	EmfRecordTypeStretchBlt              = EMR_STRETCHBLT
+	EmfRecordTypeMaskBlt                 = EMR_MASKBLT
+	EmfRecordTypePlgBlt                  = EMR_PLGBLT
+	EmfRecordTypeSetDIBitsToDevice       = EMR_SETDIBITSTODEVICE
+	EmfRecordTypeStretchDIBits           = EMR_STRETCHDIBITS
+	EmfRecordTypeExtCreateFontIndirect   = EMR_EXTCREATEFONTINDIRECTW
+	EmfRecordTypeExtTextOutA             = EMR_EXTTEXTOUTA
+	EmfRecordTypeExtTextOutW             = EMR_EXTTEXTOUTW
+	EmfRecordTypePolyBezier16            = EMR_POLYBEZIER16
+	EmfRecordTypePolygon16               = EMR_POLYGON16
+	EmfRecordTypePolyline16              = EMR_POLYLINE16
+	EmfRecordTypePolyBezierTo16          = EMR_POLYBEZIERTO16
+	EmfRecordTypePolylineTo16            = EMR_POLYLINETO16
+	EmfRecordTypePolyPolyline16          = EMR_POLYPOLYLINE16
+	EmfRecordTypePolyPolygon16           = EMR_POLYPOLYGON16
+	EmfRecordTypePolyDraw16              = EMR_POLYDRAW16
+	EmfRecordTypeCreateMonoBrush         = EMR_CREATEMONOBRUSH
+	EmfRecordTypeCreateDIBPatternBrushPt = EMR_CREATEDIBPATTERNBRUSHPT
+	EmfRecordTypeExtCreatePen            = EMR_EXTCREATEPEN
+	EmfRecordTypePolyTextOutA            = EMR_POLYTEXTOUTA
+	EmfRecordTypePolyTextOutW            = EMR_POLYTEXTOUTW
+	EmfRecordTypeSetICMMode              = 98   ' EMR_SETICMMODE
+	EmfRecordTypeCreateColorSpace        = 99   ' EMR_CREATECOLORSPACE
+	EmfRecordTypeSetColorSpace           = 100  ' EMR_SETCOLORSPACE
+	EmfRecordTypeDeleteColorSpace        = 101  ' EMR_DELETECOLORSPACE
+	EmfRecordTypeGLSRecord               = 102  ' EMR_GLSRECORD
+	EmfRecordTypeGLSBoundedRecord        = 103  ' EMR_GLSBOUNDEDRECORD
+	EmfRecordTypePixelFormat             = 104  ' EMR_PIXELFORMAT
+	EmfRecordTypeDrawEscape              = 105  ' EMR_RESERVED_105
+	EmfRecordTypeExtEscape               = 106  ' EMR_RESERVED_106
+	EmfRecordTypeStartDoc                = 107  ' EMR_RESERVED_107
+	EmfRecordTypeSmallTextOut            = 108  ' EMR_RESERVED_108
+	EmfRecordTypeForceUFIMapping         = 109  ' EMR_RESERVED_109
+	EmfRecordTypeNamedEscape             = 110  ' EMR_RESERVED_110
+	EmfRecordTypeColorCorrectPalette     = 111  ' EMR_COLORCORRECTPALETTE
+	EmfRecordTypeSetICMProfileA          = 112  ' EMR_SETICMPROFILEA
+	EmfRecordTypeSetICMProfileW          = 113  ' EMR_SETICMPROFILEW
+	EmfRecordTypeAlphaBlend              = 114  ' EMR_ALPHABLEND
+	EmfRecordTypeSetLayout               = 115  ' EMR_SETLAYOUT
+	EmfRecordTypeTransparentBlt          = 116  ' EMR_TRANSPARENTBLT
+	EmfRecordTypeReserved_117            = 117  ' Not Used
+	EmfRecordTypeGradientFill            = 118  ' EMR_GRADIENTFILL
+	EmfRecordTypeSetLinkedUFIs           = 119  ' EMR_RESERVED_119
+	EmfRecordTypeSetTextJustification    = 120  ' EMR_RESERVED_120
+	EmfRecordTypeColorMatchToTargetW     = 121  ' EMR_COLORMATCHTOTARGETW
+	EmfRecordTypeCreateColorSpaceW       = 122  ' EMR_CREATECOLORSPACEW
+	EmfRecordTypeMax                     = 122
+	EmfRecordTypeMin                     = 1
+
+	EmfPlusRecordTypeInvalid = GDIP_EMFPLUS_RECORD_BASE
+	EmfPlusRecordTypeHeader
+	EmfPlusRecordTypeEndOfFile
+
+	EmfPlusRecordTypeComment
+
+	EmfPlusRecordTypeGetDC
+
+	EmfPlusRecordTypeMultiFormatStart
+	EmfPlusRecordTypeMultiFormatSection
+	EmfPlusRecordTypeMultiFormatEnd
+
+	EmfPlusRecordTypeObject
+
+	EmfPlusRecordTypeClear
+	EmfPlusRecordTypeFillRects
+	EmfPlusRecordTypeDrawRects
+	EmfPlusRecordTypeFillPolygon
+	EmfPlusRecordTypeDrawLines
+	EmfPlusRecordTypeFillEllipse
+	EmfPlusRecordTypeDrawEllipse
+	EmfPlusRecordTypeFillPie
+	EmfPlusRecordTypeDrawPie
+	EmfPlusRecordTypeDrawArc
+	EmfPlusRecordTypeFillRegion
+	EmfPlusRecordTypeFillPath
+	EmfPlusRecordTypeDrawPath
+	EmfPlusRecordTypeFillClosedCurve
+	EmfPlusRecordTypeDrawClosedCurve
+	EmfPlusRecordTypeDrawCurve
+	EmfPlusRecordTypeDrawBeziers
+	EmfPlusRecordTypeDrawImage
+	EmfPlusRecordTypeDrawImagePoints
+	EmfPlusRecordTypeDrawString
+
+	EmfPlusRecordTypeSetRenderingOrigin
+	EmfPlusRecordTypeSetAntiAliasMode
+	EmfPlusRecordTypeSetTextRenderingHint
+	EmfPlusRecordTypeSetTextContrast
+	EmfPlusRecordTypeSetInterpolationMode
+	EmfPlusRecordTypeSetPixelOffsetMode
+	EmfPlusRecordTypeSetCompositingMode
+	EmfPlusRecordTypeSetCompositingQuality
+	EmfPlusRecordTypeSave
+	EmfPlusRecordTypeRestore
+	EmfPlusRecordTypeBeginContainer
+	EmfPlusRecordTypeBeginContainerNoParams
+	EmfPlusRecordTypeEndContainer
+	EmfPlusRecordTypeSetWorldTransform
+	EmfPlusRecordTypeResetWorldTransform
+	EmfPlusRecordTypeMultiplyWorldTransform
+	EmfPlusRecordTypeTranslateWorldTransform
+	EmfPlusRecordTypeScaleWorldTransform
+	EmfPlusRecordTypeRotateWorldTransform
+	EmfPlusRecordTypeSetPageTransform
+	EmfPlusRecordTypeResetClip
+	EmfPlusRecordTypeSetClipRect
+	EmfPlusRecordTypeSetClipPath
+	EmfPlusRecordTypeSetClipRegion
+	EmfPlusRecordTypeOffsetClip
+
+	EmfPlusRecordTypeDrawDriverString
+
+	EmfPlusRecordTotal
+
+	EmfPlusRecordTypeMax = EmfPlusRecordTotal-1
+	EmfPlusRecordTypeMin = EmfPlusRecordTypeHeader */
+End Enum
+
+End Namespace 'System
+End Namespace 'Drawing
+End Namespace 'Imaging
+
+
 #endif '__SYSTEM_DRAWING_IMAGING_MISC_AB__
